%        
%   ()  S(w)=k.*{w.^2./(w.^2+O.^2)}, 
%  tau -  , w0=2*pi*f0-  .


%     
close all
%    (WORKSPACE)
clear

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                                                       %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% T -   , 
T=8;
% tau -   , 

% N -      
N=256;
% K -    
K=20;
% k, O -  
k=8388608./19683;
O=64./27;
% dt -    
dt=T/N;
tau=2.*pi./O;
% df -    
df=1/(N*dt);
% t -      
t=(0:dt:T-dt)';
% f -   ,       
f=(-0.5/dt:df:0.5/dt-df)';
% R -      
Sp=k.*((2*pi*f(1:N)).^4./(((2*pi*f(1:N)).^2+O.^2)).^4);
Sp=[Sp(N/2+1:N); Sp(1:N/2)];
R=(fft(Sp)).*df;
R=[R(N/2:N); R(1:N/2)];
% Re - ,        
Re=zeros(size(R));
Re1=zeros(size(R));
Z=fftshift(Sp./max(Sp));
%     
figure(1)
plot(f,Z)
title('  ')
xlabel('f, ')
ylabel('S(f)')
grid

% Nidle -        
%              (  )
Nidle=round(3*tau./dt);
% W -     
%W=1/tau;
% a, b -   
%  
a0=(2+dt.*O).^3;
a1=3.*(-2+dt.*O).*((2+dt.*O).^2);
a2=3.*((-2+dt.*O).^2).*(2+dt.*O);
a3=(-2+dt.*O).^3;
b0=(dt.^2).*2.*sqrt(k);
b1=4.*sqrt(k).*(dt.^2);
b2=-4.*sqrt(k).*(dt.^2);
b3=-2.*(dt.^2).*sqrt(k);
y=zeros(N,1);

%n=0:N;

%1
%  u0
%x=[1; zeros(N,1)]; 
%  
%y=filter(b, a, x);
%figure(1);
%plot(n,y)
%hold on
%stem(n,x)
%stem(n,y)
%grid




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                            %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

for k=1:K
   % x -      ( )
   x=randn(N,1)./(sqrt(2*pi.*dt));
   % y1 -     
   y1=0;
   y2=0;
   y3=0;
   %    
   for n=4:Nidle
      y(n)=-a1./a0.*y(n-1)-a2./a0.*y(n-2)-a3./a0.*y(n-3)+b0./a0.*x(n)+b1./a0.*x(n-1)+b2./a0.*x(n-2)+b3./a0.*x(n-3);
       %y(n)=-a1./a0.*y(n-1)-a2./a0.*y(n-2)-a3./a0.*y(n-3)+b0./a0.*x(n)+b1./a0.*x(n-1);
   end;
   %    
   y(1,1)=y(n-2); %   
  y(2,1)=y(n-1);
  y(3,1)=y(n);
   for n=4:N
      %   
      y(n)=-a1./a0.*y(n-1)-a2./a0.*y(n-2)-a3./a0.*y(n-3)+b0./a0.*x(n)+b1./a0.*x(n-1)+b2./a0.*x(n-2)+b3./a0.*x(n-3);
      %y(n,1)=-a1./a0.*y(n-1)-a2./a0.*y(n-2)-a3./a0.*y(n-3)+b0./a0.*x(n)+b1./a0.*x(n-1);
   end;

%   k-   
figure(2)
plot(t,real(y));
title(['  , k=' int2str(k)])
xlabel('t, ')
ylabel('s(t)')
grid
%pause(1)

%      
% Ree -    k-   
Ree=xcorr(y,y,N/2,'coeff');
%      
Re=Re+Ree;
end

%     
Re=Re./K;
% R       
R=[R Re];

%  
a0=(1+dt.*O).^3;
a1=-3.*((1+dt.*O).^2);
a2=3.*(1+dt.*O);
a3=-1;
b0=((dt).^2).*sqrt(k);
b1=-((dt).^2).*sqrt(k);
y=zeros(N,1);

for k=1:K
   % x -      ( )
   x=randn(N,1)./(sqrt(2*pi.*dt));
   % y1 -     
   y1=0;
   y2=0;
   y3=0;
   %    
   for n=4:Nidle
      y(n)=-a1./a0.*y(n-1)-a2./a0.*y(n-2)-a3./a0.*y(n-3)+b0./a0.*x(n)+b1./a0.*x(n-1);
       %y(n)=-a1./a0.*y(n-1)-a2./a0.*y(n-2)-a3./a0.*y(n-3)+b0./a0.*x(n)+b1./a0.*x(n-1);
   end;
   %    
   y(1,1)=y(n-2); %   
  y(2,1)=y(n-1);
  y(3,1)=y(n);
   for n=4:N
      %   
      y(n)=-a1./a0.*y(n-1)-a2./a0.*y(n-2)-a3./a0.*y(n-3)+b0./a0.*x(n)+b1./a0.*x(n-1);
      %y(n,1)=-a1./a0.*y(n-1)-a2./a0.*y(n-2)-a3./a0.*y(n-3)+b0./a0.*x(n)+b1./a0.*x(n-1);
   end;

%   k-   
figure(2)
plot(t,real(y));
title(['  , k=' int2str(k)])
xlabel('t, ')
ylabel('s(t)')
grid
%pause(1)

%      
% Ree -    k-   
Ree1=xcorr(y,y,N/2,'coeff');
%      
Re1=Re1+Ree1;
end

%     
Re1=Re1./K;
% R       
R=[R Re1];

%   : 
% -  ,  
% -  ,  
figure(3)
plot([t;T]-0.5*T,real(R))
title(' :    ')
xlabel('\tau, c')
ylabel('R(\tau)')
grid